#-*- mode: python; mode: fold -*-
from Globals import InitializeClass
from AccessControl import ClassSecurityInfo

from Products.CMFCore.utils import UniqueObject, getToolByName
from Products.CMFCore.permissions import View
from Products.CMFCore.permissions import ModifyPortalContent
from Products.CPSCore.CPSBase import CPSBase_adder, CPSBaseFolder 
#from Products.CPSCore.CPSBase import CPSBaseDocument as BaseDocument 
from Products.CPSDocument.CPSDocument import CPSDocument 
#from Products.CPSCore.CPSBase import CPSBaseBTreeFolder as BaseBTreeFolder 
#from Products.CPSCore.CPSBase import CPSBaseBTreeDocument as BaseBTreeDocument 
#from Products.CMFCore.DirectoryView import registerDirectory

#registerDirectory('skins', globals())
#registerDirectory('skins/waeup_default', globals())
#registerDirectory('skins/waeup_faculty', globals())

class SCFolder(CPSDocument): ###(
    """
    WAeUP StudyCourseFolder containing StudyCourses 
    """
    meta_type = 'SCFolder'
    portal_type = meta_type
    security = ClassSecurityInfo()
    
    def __init__(self, id, **kw):
        CPSDocument.__init__(self, id, **kw)

    security.declareProtected(View,"Title")
    def Title(self):
        """compose title"""
        return "SCFolder of %s" % (self.title)

InitializeClass(SCFolder)

def addSCFolder(container, id, REQUEST=None, **kw):
    """Add a SCFolder."""
    ob = SCFolder(id, **kw)
    return CPSBase_adder(container, ob, REQUEST=REQUEST)

###)

class StudyCourse(CPSDocument): ###(
    """
    WAeUP StudyCourse 
    """
    meta_type = 'StudyCourse'
    portal_type = meta_type
    security = ClassSecurityInfo()
    
    def __init__(self, id, **kw):
        CPSDocument.__init__(self, id, **kw)

##    security.declareProtected(View,"Title")
##    def Title(self):
##        """compose title"""
##        return "StudyCourse of %s" % (self.title)

InitializeClass(StudyCourse)

def addStudyCourse(container, id, REQUEST=None, **kw):
    """Add a StudyCourse."""
    ob = StudyCourse(id, **kw)
    return CPSBase_adder(container, ob, REQUEST=REQUEST)

###)

class Faculty(CPSDocument): ###(
    """
    WAeUP Faculty containing Departments 
    """
    meta_type = 'Faculty'
    portal_type = meta_type
    security = ClassSecurityInfo()
    
##    def __init__(self, id, **kw):
##        CPSDocument.__init__(self, id, **kw)

    security.declareProtected(View,"Title")
    def Title(self):
        """compose title"""
        return "%s" % (self.title)

InitializeClass(Faculty)

def addFaculty(container, id, REQUEST=None, **kw):
    """Add a Faculty."""
    ob = Faculty(id, **kw)
    return CPSBase_adder(container, ob, REQUEST=REQUEST)

###)

class Department(CPSDocument): ###(
    """
    WAeUP Department containing the courses and students
    """
    meta_type = 'Department'
    portal_type = meta_type
    security = ClassSecurityInfo()

##    security.declareProtected(View,"Title")
##    def Title(self):
##        """compose title"""
##        reg_nr = self.getId()[1:]
##        return "Department of %s" % (self.title)

InitializeClass(Department)

def addDepartment(container, id, REQUEST=None, **kw):
    """Add a Department."""
    ob = Department(id, **kw)
    return CPSBase_adder(container, ob, REQUEST=REQUEST)
###)

class Course(CPSDocument): ###(
    """
    WAeUP Course  
    """
    meta_type = 'Course'
    portal_type = meta_type
    security = ClassSecurityInfo()

    security.declareProtected(View,"Title")
    def Title(self):
        """compose title"""
        return self.title
    
InitializeClass(Course)

def addCourse(container, id, REQUEST=None, **kw):
    """Add a Course."""
    ob = Course(id, **kw)
    return CPSBase_adder(container, ob, REQUEST=REQUEST)
###)

class CourseTicket(CPSDocument): ###(
    """
    WAeUP CourseTicket  
    """
    meta_type = 'CourseTicket'
    portal_type = meta_type
    security = ClassSecurityInfo()
    
InitializeClass(CourseTicket)

def addCourseTicket(container, id, REQUEST=None, **kw):
    """Add a CourseTicket."""
    ob = CourseTicket(id, **kw)
    return CPSBase_adder(container, ob, REQUEST=REQUEST)
###)
